#TITLE=WebFOCUS User Written Subroutines
#INFO
New Cliptext library
#SORT=y

#T=ABS (How to Calculate Absolute Value)
ABS(^!argument)
-* How to Calculate Absolute Value 
-* where: 
-* argument : Numeric
-* Is the value for which the absolute value is returned, the name of a field that contains the value, or an expression that returns the value. If you use an expression, use parentheses as needed to ensure the correct order of evaluation.

#T=ADD (How to Add Days to a Date) - (Maintain Only)
ADD(^!date,value)
-* or date.ADD(value)
-*
-* How to Add Days to a Date 
-* where: 
-* date : 
-* Is the date to add days to, or a field containing the date.
-*
-* value :
-* Is the number of days by which to increase the date.
-*
-* This function changes the value of date. 

#T=ARGLEN (How to Measure the Length of a Character String)
ARGLEN(^!inlength, infield, outfield)
-* How to Measure the Length of a Character String 
-* where: 
-* inlength : Integer
-* Is the length of the field containing the character string, or a field that contains the length.
-*
-* infield : Alphanumeric
-* Is the name of the field containing the character string.
-*
-* outfield : Integer 
-* Is the field that contains the result, or the format of the output value enclosed in single quotation marks.
-*
-*In Dialogue Manager, you must specify the format. In Maintain, you must specify the name of the field.

#T=ASIS
ASIS (^!argument)
#T=ATODBL (How to Convert an Alphanumeric String to Double-Precision Format)
ATODBL(^!string, length, outfield)
-* where: string   Alphanumeric
-*                 Is the alphanumeric string to be converted, or a field or variable that contains the string.
-* 
-*        length   Alphanumeric
-*                 Is the two-character length of infield in bytes.
-*                 This can be a numeric constant, or a field or variable that contains the value.
-*                 If you specify a numeric constant, enclose it in single quotation marks.
-*                 The maximum value is 15.
-* 
-*        outfield Double precision floating-point
-*                 Is the name of the field that contains the result,
-*                 or the format of the output value enclosed in single quotation marks.
-* 
-* In Dialogue Manager, you must specify the format. In Maintain, you must specify the name of the field.

#T=AYM
AYM(^!indate, months, outfield)
#T=AYMD
AYMD(^!indate, days, outfield)
#T=BAR
BAR (^!barlength, infield, maxvalue, 'char', outfield)
#T=BITSON
BITSON (^!bitnumber, infield, outfield)
#T=BYTVAL
BYTVAL(^!character, outfield)
#T=CALLDOS
CALLDOS (^!length, 'string ', returncode)
#T=CHARGET
CHARGET (num, infield, outfield)
#T=CHGDAT
CHGDAT('oldformat', 'newformat', indate, outfield)
#T=CHKFMT
CHKFMT(^!numchar, infield, 'mask', outfield)
#T=CHKPCK
CHKPCK (^!inlength, infield, error, outfield)
#T=CTRAN
CTRAN(^!inlen, infield, decfrm, decto, output)
#T=CTRFLD
CTRFLD(^!infield, inlength, outfield)
#T=DADMY
DADMY(^!indate, outfield)
#T=DADYM
DADYM(^!indate, outfield)
#T=DAMDY
DAMDY(^!indate, outfield)
#T=DAMYD
DAMYD(^!indate, outfield)
#T=DAYDM
DAYDM(^!indate, outfield)
#T=DAYMD
DAYMD(^!indate, outfield)
#T=DECODE
DECODE ^!fieldname (code1 result1 code2 result2...[ELSE default ]);
#T=DECODEF
DECODE ^!fieldname (ddname [ELSE default ]);
#T=DMOD
DMOD(^!dividend, divisor, outfield)
#T=DMY
DMY(^!begin, end)
#T=DOWK
DOWK(^!indate, outfield)
#T=DOWKL
DOWKL(indate, outfield)
#T=DTDMY
DTDMY(^!number, outfield)
#T=DTDYM
DTDYM(^!number, outfield)
#T=DTMDY
DTMDY(^!number, outfield)
#T=DTMYD
DTMYD(^!number, outfield)
#T=DTYDM
DTYDM(^!number, outfield)
#T=DTYMD
DTYMD(^!number, outfield)
#T=EDITF
EDIT(^!fieldname);
#T=EDITS
EDIT(^!fieldname, 'mask');
#T=EXP
EXP(^!power, outfield)
#T=EXPN
EXPN(^!argument)
#T=FGETENV
FGETENV(^!envnamelen, envname, outfieldlen, outfldformat)
#T=FMOD
FMOD(^!dividend, divisor, outfield)
#T=FPUTENV (How to Assign a Value to an Environment Variable)
FPUTENV (namelength,'name',valuelength, 'value', outfield)
-* where: 
-* namelength : Integer
-* Is the maximum length of the name of the Environment variable.
-* 
-* name : Alphanumeric
-* Is the name of the environment variable enclosed in single quotation marks. The name must be right-justified and padded with blanks to the maximum length specified by namelength.
-*
-* valuelength  : number
-* Is the maximum length of the environment variable value. 
-*
-* Note: The sum of namelength and valuelength cannot exceed 64. 
-*
-* value : string
-* Is the value you wish to assign to the environment variable. The string must be right-justified and contain no embedded blanks. Strings that contain embedded blanks are truncated at the first blank.
-*
-* outfield : Integer
-* Is the name of the field that contains the result, or the format of the output value enclosed in single quotation marks. If the variable is set successfully, the return code is 0; any other value indicates a failure occurred.
#T=FTOA
FTOA(^!number, '(format)', outfield)
#T=GETTOK
GETTOK(^!infield, inlen, toknum, delim, outlen, outfield)
#T=GETUSER
GETUSER (^!outfield)
#T=GREGDT
GREGDT(^!indate, outfield)
#T=HEXBYT
HEXBYT(^!input, output)
#T=HHMMSS
HHMMSS(^!outfield)
#T=IMOD
IMOD(^!dividend, divisor, outfield)
#T=INT
INT(^!argument)
#T=ISALIVE
ISALIVE(^!filename, handle)
#T=ITONUM
ITONUM(^!sigbytes, infield, outfield)
#T=ITOPACK
ITOPACK(^!sigbytes, infield, outfield)
#T=ITOZ
ITOZ(^!outlength, number, outfield)
#T=JULDAT
JULDAT(^!indate, outfield)
#T=LCWORD
LCWORD(^!inlength, infield, outfield) 
#T=LJUST (How to Left-Justify a Character String)
LJUST(length,^!string, outfield)
-*where: length   Integer
-*                Is the length in characters of string and outfield,
-*                or a field that contains the length.
-*
-*       string   Alphanumeric
-*                Is the character string to be justified,
-*                or a field or variable that contains the string.
-*
-*       outfield Alphanumeric
-*                Is the name of the field that contains the result,
-*                or the format of the output value enclosed in single quotation marks.
-*
-* In Dialogue Manager, you must specify the format. 

#T=LOCASE
LOCASE(^!inlength, infield, outfield)
#T=LOG
LOG(^!argument)
#T=MAX
MAX(^!argument1, argument2, ...)
#T=MDY
MDY(^!begin, end)
#T=MIN
MIN(^!argument1, argument2, ...)
#T=OVRLAY
OVRLAY(^!base, baselen, substring, sublen, position, outfield)
#T=PARAG
PARAG(^!inlen, infield, delim, subsize, outfield)
#T=PCKOUT
PCKOUT(^!infield, outlength, outfield)
#T=POSIT
POSIT(^!parent, inlength, substring, sublength, outfield)
#T=PTOA (How to Convert a Packed-Decimal Number to Alphanumeric Format)
PTOA(^number, '(format)', outfield)

-* where: number Numeric P (packed-decimal)
-*               Is the number to be converted, or the name of the field that contains the number.
-*        format Alphanumeric
-*               Is the output format of the number enclosed in both single quotation marks and parentheses. 
-*               Only packed-decimal format is supported. Include any edit options that you want to display in the output. 
-*
-* The format value does not require the same length or number of decimal places as the original field.
-* If you change the number of decimal places, the result is rounded.
-* If you make the length too short to hold the integer portion of the number, asterisks appear instead of the number.
-*
-* If you use a field name for this argument, specify the name without quotation marks or parentheses.
-* However, parentheses must be included around the format stored in this field. For example:
-* FMT/A10 = '(P12.2C)';
-* You can then use this field as the format argument when using the function in your request:
-*
-* COMPUTE ALPHA_GROSS/A20 = PTOA(PGROSS, FMT, ALPHA_GROSS);
-*
-*        outfield Alphanumeric
-*                 Is the name of the field that contains the result, or 
-*                 the format of the output value enclosed in single quotation marks.
-*                 The length of this argument must be greater than the length of number and must 
-*                 account for edit options and a possible negative sign. 
-*
-* In Dialogue Manager, you must specify the format. In Maintain, you must specify the name of the field.


#T=RANDNUM
RANDNUM(^!outfield)
#T=REVERSE
REVERSE(^!length, input, output)
#T=RJUST
RJUST(^!inlength, infield, outfield)
#T=ROUND
ROUND(^!infield, number, outfield)
#T=SIMILAR
SIMILAR(^!inlength1, string1, inlength2, string2, outfield)
#T=SOUNDEX
SOUNDEX(^!inlength, infield, outfield)
#T=SPACE
SPACE(^!drive, freespace)
#T=SPELLNUM
SPELLNUM(^!outlength, infield, outfield)
#T=SQRT
SQRT(^!argument)
#T=SQUEEZ (How to Reduce Multiple Spaces to a Single Space)
SQUEEZ(^!length, string, outfield)
-* How to Reduce Multiple Spaces to a Single Space 
-* where: 
-*
-* length : Integer
-* Is the length in characters of string and outfield, or a field that contains the length.
-*
-* string : Alphanumeric
-*Is the character string enclosed in single quotation marks, r the field that contains the character string.
-*
-* outfield : Alphanumeric
-* Is the field that contains the result, or the format of the output value enclosed in single quotation marks. 
-*
-*In Dialogue Manager, you must specify the format. In Maintain, you must specify the name of the field.


#T=STRREP (How to Replacing Character Strings)
STRREP (inlength, ^instring, searchlength, searchstring, replength, repstring, outlength, outstring)

-* where: inlength     Numeric
-*                     Is the number of characters in the input string.
-*        instring     Alphanumeric
-*                     Is the input string.
-*        searchlength Numeric
-*                     Is the number of characters in the (shorter length) string to be replaced.
-*        searchstring Alphanumeric
-*                     Is the character string to be replaced.
-*        replength    Numeric
-*                     Is the number of characters in the replacement string. Must be zero (0) or greater.
-*        repstring    Alphanumeric
-*                     Is the replacement string (alphanumeric). Ignored if replength is zero (0).
-*        outlength    Numeric
-*                     Is the number of characters in the resulting output string. Must be 1 or greater.
-*        outstring    Alphanumeric
-*                     Is the resulting output string after all replacements and padding.


#T=SUBSTR
SUBSTR(^!inlength, parent, start, end, sublength, outfield)
#T=TODAY
TODAY(^!outfield)
#T=TRIM (How to Remove Leading and Trailing Occurrences)
TRIM(trim_where,^string,string_length,pattern,pattern_length,outfield)

-* where: trim_where       Alphanumeric
-*                         Is one of the following, which indicates where to remove the pattern: 
-*                           'L' removes leading occurrences.
-*                           'T' removes trailing occurrences.
-*                           'B' removes both leading and trailing occurrences.
-*        string           Alphanumeric
-*                         Is the source character string enclosed in single quotation marks, or the field containing the string.
-*        string_length    Integer
-*                         Is the length of the string in characters.
-*        pattern          Alphanumeric
-*                         Is the pattern to remove enclosed in single quotation marks.
-*        pattern_length   Integer
-*                         Is the number of characters in the pattern.
-*        outfield         Alphanumeric
-*                         Is the field to which the result is returned, or the format of the output value enclosed in single quotation marks. 
-*
-* In Dialogue Manager, the format must be specified.


#T=UFMT
UFMT(^!infield, inlength, outfield)
#T=UPCASE
UPCASE(^!length, input, output)
#T=YM
YM(^!fromdate, todate, outfield)
#T=YMD
YMD(^!begin, end)
#